package com.its.op.service.its.vds;

import com.its.op.dao.repository.its.code.TbCmmnCdRepository;
import com.its.op.dao.repository.its.vds.TbVdsDtctRltnLinkRepository;
import com.its.op.dao.repository.its.vds.TbVdsDtctRepository;
import com.its.op.dto.its.code.VdsDtctTypeDto;
import com.its.op.dto.its.vds.TbVdsDtctDto;
import com.its.op.entity.its.code.TbCmmnCd;
import com.its.op.entity.its.vds.TbVdsDtct;
import com.its.op.entity.its.vds.TbVdsDtctLinkRltn;
import com.its.op.global.CodeManager;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVdsDtctService {

    private final TbVdsDtctRepository repo;
    private final TbVdsDtctRltnLinkRepository linkRltnRepo;
    private final TbCmmnCdRepository codeRepo;

    // 데이터 1건 조회, 없으면 exception
    private TbVdsDtct requireOne(Long id) throws NoSuchElementException {
        Optional<TbVdsDtct> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVdsDtctDto> findAll() {
        List<TbVdsDtctDto> result = new ArrayList<>();
        List<TbVdsDtct> data = this.repo.findAll();
        for (TbVdsDtct entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    /**
     * 삭제되지 않은 전체 VMS 목록 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVdsDtctDto> findAllList() {
        List<TbVdsDtctDto> result = new ArrayList<>();
        List<TbVdsDtct> data = this.repo.findAllList();
        data.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbVdsDtctDto findById(Long id) {
        TbVdsDtct entity = requireOne(id);
        return entity.toDto();
    }

    /**
     * 검지기 정보 업데이트
     * @param id
     * @param req
     * @return
     */
    @Transactional
    public TbVdsDtctDto updateById(Long id, TbVdsDtctDto.TbVdsDtctUpdReq req) {
        TbVdsDtct entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);

        TbVdsDtctLinkRltn linkRltn = new TbVdsDtctLinkRltn(req.getVdsDtctNmbr(), req.getLinkId());
        this.linkRltnRepo.save(linkRltn);

        return entity.toDto();
    }

    /**
     * 검지기 정보 목록 저장
     * @param reqList
     * @return
     */
    @Transactional
    public List<TbVdsDtctDto> mergeInfoList(List<TbVdsDtctDto.TbVdsDtctUpdReq> reqList) {
        List<TbVdsDtctDto> result = new ArrayList<>();
        for (TbVdsDtctDto.TbVdsDtctUpdReq req : reqList) {
            // 검지기 마스터 정보 저장
            TbVdsDtct obj = req.toEntity();
            this.repo.save(obj);

            // 검지기 링크 관계설정 정보 저장
            TbVdsDtctLinkRltn linkRltn = new TbVdsDtctLinkRltn(req.getVdsDtctNmbr(), req.getLinkId());
            this.linkRltnRepo.save(linkRltn);

            result.add(obj.toDto());
        }
        return result;
    }

    /**
     * 검지기 정보 저장
     * @param req
     * @return
     */
    @Transactional
    public TbVdsDtctDto mergeInfo(TbVdsDtctDto.TbVdsDtctUpdReq req) {
        // 검지기 마스터 정보 저장
        TbVdsDtct obj = req.toEntity();
        this.repo.save(obj);

        // 검지기 링크 관계설정 정보 저장
        TbVdsDtctLinkRltn linkRltn = new TbVdsDtctLinkRltn(req.getVdsDtctNmbr(), req.getLinkId());
        this.linkRltnRepo.save(linkRltn);
        return obj.toDto();
    }

    /**
     * 검지기 정보 개별 삭제
     * @param id
     * @return
     */
    @Transactional
    public TbVdsDtctDto deleteById(Long id) {
        TbVdsDtct entity = requireOne(id);
        // 검지기 링크 관계설정 정보 삭제
        this.linkRltnRepo.deleteById(id);
        // 검지기 마스터 정보 삭제
        entity.setDelete();
        //this.repo.deleteById(id);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbVdsDtctDto> deleteByIds(List<Long> ids) {
        List<TbVdsDtctDto> result = new ArrayList<>();
        for (Long id : ids) {
            // 검지기 링크 관계설정 정보 삭제
            this.linkRltnRepo.deleteById(id);
            Optional<TbVdsDtct> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                // 검지기 마스터 정보 삭제
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    /**
     * 검지기 유형(방향) 코드 정보 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<VdsDtctTypeDto> findAllDtctType() {
        List<VdsDtctTypeDto> result = new ArrayList<>();
        List<TbCmmnCd> data = this.codeRepo.findAllByCmmnClsfCd(CodeManager.DTCT_TYPE_CD);
        data.forEach(obj -> {
            if (("Y").equals(obj.getUseYn())) {
                result.add(VdsDtctTypeDto.makeDto(obj));
            }
        });
        return result;
    }
}
